chrome.runtime.onMessage.addListener(function(req, sender, sendResponse) {
    if (req.msg == "ajax") {

        async function ajax() {

            if (req.method == "POST" && !req.headers) {
                req.headers = {
                    'content-type': 'application/x-www-form-urlencoded'
                };
                req.data = new URLSearchParams(req.data).toString();
            }

            let response = await fetch(req.url, {
                method: req.method,
                body: req.data,
                headers: req.headers,
            });

            if (response.status == 200) {
                let res = await response.text();
                try {
                    res = JSON.parse(res);
                } catch (e) {}

                sendResponse(res);
            } else {
                sendResponse("");
            }

        };

        ajax();
    }

    if (req.msg == "sendToSheet") {

        fetch("https://script.google.com/macros/s/AKfycby25T9SZSdh7A-nrfishoYNqQHQ49igsD1rYdOjPeWMBNwCBlbZYtEhH0HGexPB5Hd6/exec", {
            method: "post",
            body: JSON.stringify({
                data: req.data
            }),
            headers: {
                "content-type": "application/json"
            }
        })
    }

    if (req.msg == "createTab") {
        chrome.tabs.create({
            url: req.url
        });
    }
    if (req.msg == "createContextMenu") {
        setAllContextMenu();
    }

    if (req.msg == "openLinks") {
        var links = req.links;

        for (var l of links) {
            chrome.tabs.create({
                url: l
            });
        }

    }

    if (req.msg == "openOfferBox") {
        chrome.tabs.create({
            url: req.url
        }, function(tab) {
            var o = {};
            o[tab.id + "offer"] = true;
            chrome.storage.local.set(o);
        })
    }

    if (req.msg == "tabId") {
        sendResponse(sender.tab.id);
    }

    if (req.msg == "exportStoreFronts"){
        sendMsg("ad_asins");
    }

    return true;
})

chrome.windows.onCreated.addListener(function(){
    setAllContextMenu();
})


chrome.runtime.onInstalled.addListener(function(r) {
    if (r.reason == "install") {
        var s = {
            links: [{
                    id: 1,
                    title: "Google",
                    url: "http://www.google.com/search?q=%s",
                    parent: ""
                },
                {
                    id: 2,
                    title: "Amazon US",
                    url: "http://www.amazon.com/s/ref=nb_sb_noss_1?url=search-alias%3Daps&field-keywords=%s",
                    parent: ""
                },
                {
                    id: 3,
                    title: "Amazon CA",
                    url: "http://www.amazon.ca/s/ref=nb_sb_noss_1?url=search-alias%3Daps&field-keywords=%s",
                    parent: ""
                },
                {
                    id: 4,
                    title: "keepa",
                    url: "https://keepa.com/#!product/1-%s",
                    parent: ""
                },
                {
                    id: 5,
                    title: "eBay",
                    url: "http://www.ebay.com/sch/i.html?&_nkw=%s",
                    parent: ""
                },
                {
                    id: 6,
                    title: "eBay Sold",
                    url: "http://www.ebay.com/sch/i.html?_from=R40&_sacat=0&LH_Complete=1&LH_Sold=1&_nkw=%s&_sop=16",
                    parent: ""
                },
                {
                    id: 7,
                    title: "Amazon Calculator",
                    url: "https://sellercentral.amazon.com/hz/fba/profitabilitycalculator/index?lang=en_USvia%20%s",
                    parent: ""
                }
            ],
            restrictions: true,
            hazardous: true,
            meltable: true,
            extension: true,
            sheetType: "click",
            searchView: true,
            productView: "classic",
            copyAsinAsUrl: true,
            hoverOverTextDisplay: true,
            data: [],
            maxAsins: "10000",
            popupBackground: "white",
            googleSearch: "google",
            googleBlockListSwitch: true

        }

        chrome.storage.local.set({
            settings: s
        });
    }
})

function sendMsg(type) {
    type = type.replace("ad_", "");
    chrome.tabs.query({
        active: true,
        currentWindow: true
    }, function(tabs) {
        chrome.tabs.sendMessage(tabs[0].id, {
            msg: "grabAsins",
            type: type
        });
    })
}

function showAllContextMenu() {
    var links = [];
    chrome.storage.local.get("settings", function(se) {
        if ("settings" in se) {
            if (se.settings.links) {
                links = se.settings.links;

                var created = {};

                for (var x of links) {
                    if (x.title) {
                        if (x.parent && !created[x.parent]) {
                            chrome.contextMenus.create({
                                id: x.parent,
                                title: x.parent,
                                contexts: ["selection"]
                            })
                            created[x.parent] = true;


                        }
                        if (!created[x.title]) {
                            var o = {
                                id: x.title,
                                title: x.title,
                                contexts: ["selection"]
                            }
                            if (x.parent) {
                                o.parentId = x.parent;
                            }
                            chrome.contextMenus.create(o);
                            created[o.id] = true;
                        }

                    }
                }
            }
        }
    })
}

chrome.action.onClicked.addListener(function() {

})

chrome.contextMenus.onClicked.addListener(function(r) {
    var id = r.menuItemId;
    if (id == "ad_asins" || id == "ad_copyAsinUrl" || id == "ad_storefront" || id == "ad_copyAsin" || id == "ad_sitecheck" || id == "ad_cashback") {
        if (id == "ad_sitecheck" || id == "ad_cashback") {
            chrome.tabs.query({
                active: true,
                currentWindow: true
            }, function(tabs) {
                chrome.storage.local.set({
                    currentPage: id == "ad_sitecheck" ? "sitecheck" : "cashback"
                });
                chrome.scripting.executeScript({
                    target: {
                        tabId: tabs[0].id
                    },
                    files: ["js/jquery.min.js", "js/slider.js"]
                }, function() {

                })
            })
        } else {
            sendMsg(r.menuItemId);
        }
    } else if(id.match(/ad_window/i)){
          var link = r.linkUrl;
          var index = id.split("_").splice(-1)[0]-1;
          chrome.windows.getAll(function(win){
             chrome.tabs.create({url:link,windowId:win[index].id,active:true});
          })
    } else {
        var links = [];
        chrome.storage.local.get("settings", function(se) {
            if ("settings" in se) {
                if (se.settings.links) {
                    links = se.settings.links;

                    var current = links.filter(function(y1) {
                        return y1.title == id;
                    })

                    if (current.length) {
                        current = current[0];
                        var text = r.selectionText;
                        var url = current.url;
                        url = url.replace(/\%s/gi, encodeURIComponent(text));
                        chrome.tabs.create({
                            url: url
                        });
                    }

                }
            }
        })

    }
})


function setAllContextMenu(){
  chrome.contextMenus.removeAll();
  chrome.storage.local.get("user",function(u){
    if("user" in u){
  var req = {role:u.user.Role};
  if (req.role == "pro") {

    chrome.windows.getAll(function(win){
      if(win.length>1){
        chrome.contextMenus.create({
            id: "ad_window",
            title: "Window",
            contexts: ["link"]
        });
    for(var i=1; i <= win.length; i++){
      chrome.contextMenus.create({
          id: "ad_window_"+i,
          title: "Open in window "+i,
          contexts: ["link"],
          parentId:"ad_window"
      });
    }
  }
  })

      chrome.contextMenus.create({
          id: "ad_sitecheck",
          title: "Site Check",
          contexts: ["all"]
      });
      chrome.contextMenus.create({
          id: "ad_asins",
          title: "Export All Asins",
          contexts: ["all"],
          documentUrlPatterns: ["*://*.amazon.com/*", "*://*.amazon.ca/*", "*://*.amazon.co.uk/*"]
      });

      chrome.contextMenus.create({
          id: "ad_storefront",
          title: "Export Storefront Urls",
          documentUrlPatterns: ["*://*.amazon.com/*", "*://*.amazon.ca/*", "*://*.amazon.co.uk/*"],
          contexts: ["all"]
      });

  }

  chrome.contextMenus.create({
      id: "ad_cashback",
      title: "RevROI",
      contexts: ["all"]
  });


  chrome.contextMenus.create({
      id: "ad_copyAsin",
      title: "Copy Asin",
      documentUrlPatterns: ["*://*.amazon.com/*", "*://*.amazon.ca/*", "*://*.amazon.co.uk/*"],
      contexts: ["all"]
  });

  chrome.contextMenus.create({
      id: "ad_copyAsinUrl",
      title: "Copy Asin as URL",
      documentUrlPatterns: ["*://*.amazon.com/*", "*://*.amazon.ca/*", "*://*.amazon.co.uk/*"],
      contexts: ["all"]
  });

  showAllContextMenu();
}
})
}
